/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_spi.h
** Last modified Date:  2013-04-20
** Last Version:        v1.0
** Description:         spii2sģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-20
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#ifndef __ARCH_IO_SPI_H__
#define __ARCH_IO_SPI_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "infra/rhb_type.h"

/*********************************************************************************************************
** Ҫĺ궨
*********************************************************************************************************/
// SPI_InitulConfig궨,ȡмĻ
// ģʽѡ
#define SPI_DIR_2Lines_FullDuplex       0x0000
#define SPI_DIR_2Lines_RxOnly           0x0400
#define SPI_DIR_1Lines_Rx               0x8000
#define SPI_DIR_1Lines_Tx               0xC000

//  ѡ
#define SPI_MODE_Master                 0x0104
#define SPI_MODE_Slave                  0x0000

//  ݳѡ
#define SPI_DATA_Len8                   0x0000
#define SPI_DATA_Len16                  0x0800

// շʱSPI_CLKѡ
#define SPI_CPOL_Low                    0x0000
#define SPI_CPOL_High                   0x0002

// ʱӲλѡ
#define SPI_CPHA_1Edge                  0x0000
#define SPI_CPHA_2Edge                  0x0001

// ӻƬѡ
#define SPI_NSS_Soft                    0x0200
#define SPI_NSS_Hard                    0x0000

// SPIʷƵѡ
#define SPI_Baud_Prescaler_2            0x0000
#define SPI_Baud_Prescaler_4            0x0008
#define SPI_Baud_Prescaler_8            0x0010
#define SPI_Baud_Prescaler_16           0x0018
#define SPI_Baud_Prescaler_32           0x0020
#define SPI_Baud_Prescaler_64           0x0028
#define SPI_Baud_Prescaler_128          0x0030
#define SPI_Baud_Prescaler_256          0x0038

// λMSBʼǴLSBʼѡ
#define SPI_First_MSB                   0x0000
#define SPI_First_LSB                   0x0080

// SPI_I2S_IntEnableSPI_I2S_IntDisableĲ壬ָʹܵжԴ
#define SPI_I2S_INT_TXE                 (1<<7)
#define SPI_I2S_INT_RXNE                (1<<6)
#define SPI_I2S_INT_ERR                 (1<<5)

// SPI_I2S_DMAEnableSPI_I2S_DMADisableĲ
#define SPI_I2S_DMA_TX                  (1<<1)
#define SPI_I2S_DMA_RX                  (1<<0)

/*********************************************************************************************************
** 꺯һЩ
*********************************************************************************************************/
#define SPI_Busy(ulBase)                (HWREG(ulBase+SPI_O_SR) & 0x80)  // Ϊ0ʾSPI߲æ0ʾæ
#define SPISpaceAvial(ulBase)           (!(HWREG(ulBase+SPI_O_SR) & 0x02))// 0ͻգ0ͻ
#define SPICharsAvial(ulBase)           (HWREG(ulBase+SPI_O_SR) & 0x01)  // 0,ջգ0ջǿ

// ͨƬѡֻƬѡΪʱЧ
#define SPI_SSSet(ulBase)               (HWREG(ulBase+SPI_O_CR1) |= 0x0100)
#define SPI_SSReset(ulBase)             (HWREG(ulBase+SPI_O_CR1) &= 0xFEFF)
/*********************************************************************************************************
** ⲿ
*********************************************************************************************************/
extern void SPIInit(unsigned long ulBase,unsigned long ulConfig);
extern void SPI_SSOutEnable(unsigned long ulBase);
extern void SPI_SSOutDisable(unsigned long ulBase);
extern void SPIEnable(unsigned long ulBase);
extern void SPIDisable(unsigned long ulBase);
extern void SPI_I2S_IntEnable(unsigned long ulBase,unsigned long ulIntFlag);
extern void SPI_I2S_IntEDisable(unsigned long ulBase,unsigned long ulIntFlag);
extern void SPI_I2S_DMAEnable(unsigned long ulBase,unsigned long ulDMAFlag);
extern void SPI_I2S_DMADisable(unsigned long ulBase,unsigned long ulDMAFlag);
extern void SPI_I2S_DataPut(unsigned long ulBase,unsigned short usData);
extern unsigned short SPI_I2S_DataGet(unsigned long ulBase);



#ifdef __cplusplus
    }
#endif      // __cplusplus

#endif // endif of __ARCH_IO_SPI_H__
/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
