/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_ethernet.c
** Last modified Date:  2013-04-04
** Last Version:        v1.0
** Description:         ethernetģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-04
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#include "hal/arch/inc/arch_io_memmap.h"
#include "hal/arch/inc/arch_io_reg.h"
#include "hal/arch/inc/arch_io_ethernet.h"


/*********************************************************************************************************
  ֲ
*********************************************************************************************************/

/*********************************************************************************************************
** Function name:       EthernetInit
** Descriptions:        Ethernetģ
** input parameters:    u32Base:    ethernetģַ
**                      u32Clock:   ṩ̫ģʱӣAHBʱƵ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetInit(uint32 u32Base, uint32 u32Clock)
{
    uint32 u32Temp;
    uint32 u32PhyRegValue;
    uint32 u32AutoValue;

    // u32ClockֵȷMDCģʱ
    u32Temp = HWREG32(u32Base + ETH_MACMIIAR);
    u32Temp &= 0xFFFFFFE3;
    if((u32Clock >= 20000000) && (u32Clock < 35000000)) {
        u32Temp |= (0x00000002 << 2);
    } else if((u32Clock >= 35000000) && (u32Clock < 60000000)) {
        u32Temp |= (0x00000003 << 2);
    } else if((u32Clock >= 60000000) && (u32Clock < 100000000)) {
        u32Temp |= (0x00000000 << 2);
    } else {  // ǣʱӾ100M-120M
        u32Temp |= (0x00000001 << 2);
    }
    HWREG32(u32Base + ETH_MACMIIAR) = u32Temp;

    /*
    ** 룬PHYصĳʼ
    */
    // ȡPHY LAN8700IDֱӷ
    u32PhyRegValue = EthernetPHYRead(u32Base, PHYAddress, 16);
    if(u32PhyRegValue != 0x0040) {
      return;
    }

    EthernetPHYWrite(u32Base, PHYAddress, 0, 0x8000);           //  λPHY
    while(EthernetPHYRead(u32Base, PHYAddress, 0) & 0x8000);   //  ȴλ

    //u32PhyRegValue = EthernetPHYRead(u32Base, PHYAddress, 18);

    //  PHYЭ̹
    u32Temp = EthernetPHYRead(u32Base, PHYAddress, 0);
    u32Temp |= 0x1000;
    EthernetPHYWrite(u32Base, PHYAddress, 0, u32Temp);

//    while(!((EthernetPHYRead(u32Base, PHYAddress, 1) & 0x0004)));
//    while(!((EthernetPHYRead(u32Base, PHYAddress, 1) & 0x0020)));
#if 0
    //  ȡ״̬
    if ((EthernetPHYRead(u32Base, PHYAddress, 1) & 0x0004)) {
        // Э
        if((EthernetPHYRead(u32Base, PHYAddress, 1) & 0x0020)) {
            //  ȡЭ̵Ľ
            u32PhyRegValue = EthernetPHYRead(u32Base, PHYAddress, 0);

            if (u32PhyRegValue & 0x0100) {
                //  ȫ˫ͨģʽ
                u32AutoValue = 0x00000800;
            } else {
                //  ˫ͨģʽ
                u32AutoValue = 0x00000000;
            }

            if (u32PhyRegValue & 0x2000) {
                //  100M̫ͨģʽ
                u32AutoValue |= 0x00004000;
            } else {
                //  10M̫ͨģʽ
                u32AutoValue |= 0x00000000;
            }
        } else {
            u32AutoValue = 0x00000000;
        }
    } else {
        u32AutoValue = 0x00000000;
    }
#endif

    // MACֱó100Mȫ˫ͨģʽ
    u32AutoValue = 0x00004800;

    /*  PHYʼɣЭ̽ڱu32AutoValueУȴԺMACĴ */

    /*  ̫MAC */
    /* ̫MACüĴûģʽ */
    u32Temp = HWREG32(u32Base + ETH_MACCR);
    // Clear WD, PCE, PS, TE and RE bits
    u32Temp &= 0xFF20810F;
    u32Temp |= (uint32)(0x00000000 |    //  رտŹ
                        0x00000000 |    //  رՆ¶ʱ
                        0x00000000 |    //  ̼֮֡϶Ϊ96λʱ
                        0x00000000 |    //  رز
                        0x00000000 |    //رԽܹܣȫ˫ģʽ
                        0x00000000 |    //  ѭģʽ
                        0x00000000 |    //  ԷͳԹܣͳͻʱط
                        0x00000000 |    //  MACתе֡ı֡ݣ֡ǷС1500ֽ
                        0x00000000 |    //  ˺
                        0x00000000      //  MACر˳Ӽ
                        );
#if (TCPIP_CHECKSUM_EN > 0)
    u32Temp |= 0x00000400;                      //  ʹTCP/IPӲУ͹ܣ
#endif

    u32Temp |= u32AutoValue;

    HWREG32(u32Base + ETH_MACCR) = u32Temp;    //  дý

    /* ˲ģʽã̫ι˽ݵMACַ */
    HWREG32(u32Base + ETH_MACFFR) = (0x00000000 |   //  ֹȫܣMACַ
                                 0x00000000 |   //  HASHλΪ0Ͳ
                                 0x00000000 |   //  Դַ˽
                                 0x00000040 |   //  MACתеĿ֡Ӧó
                                 0x00000000 |   //  еĹ㲥֡ͨ
                                 0x00000010 |   //  еĶಥ֡Ҫ֧IPv6ͱø
                                 0x00000000 |   //  Ŀĵַ
                                 0x00000000 |   //  ಥHASHãĴHMλ
                                 0x00000000 |   //  HASHãĴHUλ
                                 0x00000000     //  ģʽãʹܹܽ
                                );
    /* HASHбĴ */
    HWREG32(u32Base + ETH_MACHTHR) = 0x00000000;
    HWREG32(u32Base + ETH_MACHTLR) = 0x00000000;

    /* ̫MACؼĴ */
    u32Temp = HWREG32(u32Base + ETH_MACFCR);
    u32Temp &= 0x0000FF41;                       //  ձҪλ
    u32Temp |= ((0x00 << 16) |                   //  PAUSEʱ
               0x00000080   |                   //  رԶֵPAUSE֡Զ
               0x00000000   |                   //  PauseʱΪ4ʱ϶
               0x00000000   |                   //  Pause֡
               0x00000000   |                   //  رս
               0x00000000                       //  رշ
                );
    HWREG32(u32Base + ETH_MACFCR) = u32Temp;

    /* VLAN  */
    HWREG32(u32Base + ETH_MACVLANTR) = 0x00000000;

    /* DMAãDMAĿĹģʽ */
    /* ̫DMA OMRĴ */
    u32Temp = HWREG32(u32Base + ETH_DMAOMR);
    u32Temp &= 0xF8DE3F23;                       //  Ҫλ
    u32Temp |= (0x00000000 |                     //  TCP/IPCRCУ֡
               0x02000000 |                     //  ýܴ洢ת
               0x00000000 |                     //  ս֡ԴFIFO
               0x00200000 |                     //  ÷ʹ洢ת
               0x00000000 |                     //  ͷֵƣֻTSFλΪ0ʱЧЧ
               0x00000000 |                     //  ֡
               0x00000000 |                     //  Ȳ֡֡
               0x00000000 |                     //  ֵܷƣֻRSFΪ0ʱЧЧ
               0x00000004                       //  һ֡
                );
    HWREG32(u32Base + ETH_DMAOMR) = u32Temp;

    /*  DMA BMRĴ */
    HWREG32(u32Base + ETH_DMABMR) =(0x02000000 |   //  ַ
                                    0x00010000 |   //  ̶ͻ
                                    0x00400000 |   //  /* !! if 4xPBL is selected for Tx or Rx it is applied for the other */
                                    0x00002000 |
                                   (0x00000000 << 2) |   //  Ծ
                                    0x00004000 |   //  DMAٲ
                                    0x00800000     // Use separate PBL
                                );
#if (ENHANCED_DMA_DESCRIPTORS_EN > 0)
    /* Enable the Enhanced DMA descriptors */
    HWREG32(u32Base + ETH_DMABMR)  |= (uint32)0x00000080;
#endif /* ENHANCED_DMA_DESCRIPTORS_EN */

#if 0
    // PHYжϣЭж
    u32Temp = EthernetPHYRead(u32Base, PHYAddress, 30);
    u32Temp |= 0x0040;
    EthernetPHYWrite(u32Base, PHYAddress, 30, u32Temp);
#endif
}

/*********************************************************************************************************
** Function name:       EthernetPHYIntISR
** Descriptions:        PHYжеøúPHYMAC
** input parameters:    u32Base:        ̫ģַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetPHYIntISR(uint32 u32Base)
{
    uint32 u32Temp;
    uint32 u32PhyRegValue;
    uint32 u32AutoValue;

    u32Temp = HWREG32(u32Base + ETH_MACCR);

    // 10M/100M־Ͱ˫ȫ˫ı־λ
    u32Temp &= ~((uint32)0x00004800);

     //  ȡж״̬
    u32PhyRegValue = EthernetPHYRead(u32Base, PHYAddress, 29);
    // Эжϲ
    if((u32PhyRegValue & 0x0040)) {
//      while(!((EthernetPHYRead(u32Base, PHYAddress, 1) & 0x0004)));
//      while(!((EthernetPHYRead(u32Base, PHYAddress, 1) & 0x0020)));
        //  ȡЭ̵Ľ
        u32PhyRegValue = EthernetPHYRead(u32Base, PHYAddress, 0);

        if (u32PhyRegValue & 0x0100) {
            //  ȫ˫ͨģʽ
            u32AutoValue = 0x00000800;
        } else {
            //  ˫ͨģʽ
            u32AutoValue = 0x00000000;
        }

        if (u32PhyRegValue & 0x2000) {
            //  100M̫ͨģʽ
            u32AutoValue |= 0x00004000;
        } else {
            //  10M̫ͨģʽ
            u32AutoValue |= 0x00000000;
        }

        u32Temp |= u32AutoValue;
        HWREG32(u32Base + ETH_MACCR) = u32Temp;
    }
}
/*********************************************************************************************************
** Function name:       EthernetPHYRead
** Descriptions:        ȡַָPHYĴ
** input parameters:    u32Base:        ̫ģַ
**                      u8PHYDevAddr:   PHYĵַ
**                      u8PHYRegAddr:   PHYĴĵַ
** output parameters:   NONE
** Returned value:      ȡPHYĴ
*********************************************************************************************************/
uint32 EthernetPHYRead(uint32 u32Base, uint8 u8PHYDevAddr, uint8 u8PHYRegAddr)
{
    uint32 u32Temp;

    //  ȴMAC MIIַĴMAC MIIݼĴд
    while(HWREG32(u32Base + ETH_MACMIIAR) & 0x01);

    u32Temp = HWREG32(u32Base + ETH_MACMIIAR);
    u32Temp &= ~(0xFFFFFFE3);                               // CR[2:0]λ
    u32Temp |= (((uint32)u8PHYDevAddr << 11) & 0x0000F800); //  дPHYַ
    u32Temp |= (((uint32)u8PHYRegAddr << 6)  & 0x000007C0); //  дPHYĴַ
    u32Temp &= ~(0x00000002);                               //  ΪPHYĴģʽ
    u32Temp |= 0x00000001;                                  //  MIIæʼ
    HWREG32(u32Base + ETH_MACMIIAR) = u32Temp;

    //  ȶPHYĴ
    while(HWREG32(u32Base + ETH_MACMIIAR) & 0x01);
    return (HWREG32(u32Base + ETH_MACMIIDR) & 0xFFFF);
}

/*********************************************************************************************************
** Function name:       EthernetPHYRead
** Descriptions:        ȡַָPHYĴ
** input parameters:    u32Base:        ̫ģַ
**                      u8PHYDevAddr:   PHYĵַ
**                      u8PHYRegAddr:   PHYĴĵַ
**                      u32Data:        дָPHYĴ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetPHYWrite(uint32 u32Base, uint8 u8PHYDevAddr, uint8 u8PHYRegAddr, uint32 u32Data)
{
    uint32 u32Temp;

    //  ȴMAC MIIַĴMAC MIIݼĴд
    while(HWREG32(u32Base + ETH_MACMIIAR) & 0x01);

    u32Temp = HWREG32(u32Base + ETH_MACMIIAR);
    u32Temp &= ~(0xFFFFFFE3);                               // CR[2:0]λ
    u32Temp |= (((uint32)u8PHYDevAddr << 11) & 0x0000F800); //  дPHYַ
    u32Temp |= (((uint32)u8PHYRegAddr << 6)  & 0x000007C0); //  дPHYĴַ
    u32Temp |= 0x00000002;                                  //  ΪPHYĴģʽ
    u32Temp |= 0x00000001;                                  //  MIIæʼ
    HWREG32(u32Base + ETH_MACMIIDR) = u32Data;
    HWREG32(u32Base + ETH_MACMIIAR) = u32Temp;

    //  ȶPHYĴ
    while(HWREG32(u32Base + ETH_MACMIIAR) & 0x01);
}

/*********************************************************************************************************
** Function name:       EthernetEnable
** Descriptions:        ʹ̫ͺͽܵ
** input parameters:    u32Base      ̫ģַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetEnable(uint32 u32Base)
{
    HWREG32(u32Base + ETH_MACCR) |= 0x00000008;     //  ʹMAC״̬
    HWREG32(u32Base + ETH_DMAOMR) |= 0x00100000;    //  շFIFO
    HWREG32(u32Base + ETH_MACCR) |= 0x00000004;     //  ʹMAC״̬
    HWREG32(u32Base + ETH_DMAOMR) |= 0x00002000;    //  DMA
    HWREG32(u32Base + ETH_DMAOMR) |= 0x00000002;    //  DMA
}

/*********************************************************************************************************
** Function name:       EthernetMACAddrSet
** Descriptions:        ̫MACַʹMAC0MAC1-MAC3ʹ
** input parameters:    u32Base      ̫ģַ
**                      pu8MacAddr  Ҫ趨MACַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetMACAddrSet(uint32 u32Base, uint8 *pu8MacAddr)
{
    uint32 u32Temp;

    u32Temp = (((uint32)pu8MacAddr[5] << 8) | (uint32)pu8MacAddr[4]);
    HWREG32(u32Base + ETH_MACA0HR) = u32Temp;

    u32Temp = (((uint32)pu8MacAddr[3] << 24) | ((uint32)pu8MacAddr[2] << 16) |
             ((uint32)pu8MacAddr[1] << 8) | (uint32)pu8MacAddr[0]);

    HWREG32(u32Base + ETH_MACA0LR) = u32Temp;
}

/*********************************************************************************************************
** Function name:       EthernetMACAddrGet
** Descriptions:        ȡ̫MACַʹMAC0MAC1-MAC3ʹ
** input parameters:    u32Base      ̫ģַ
**                      pu8MacAddr  ȡMACַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetMACAddrGet(uint32 u32Base, uint8 *pu8MacAddr)
{
    uint32 u32Temp;

    u32Temp = HWREG32(u32Base + ETH_MACA0HR);
    pu8MacAddr[5] = ((u32Temp >> 8) & (uint8)0xFF);
    pu8MacAddr[4] = (u32Temp & (uint8)0xFF);

    u32Temp = HWREG32(u32Base + ETH_MACA0LR);
    pu8MacAddr[3] = ((u32Temp >> 24) & (uint8)0xFF);
    pu8MacAddr[2] = ((u32Temp >> 16) & (uint8)0xFF);
    pu8MacAddr[1] = ((u32Temp >> 8 ) & (uint8)0xFF);
    pu8MacAddr[0] = (u32Temp & (uint8)0xFF);
}

/*********************************************************************************************************
** Function name:       EthernetReset
** Descriptions:        λ̫
** input parameters:    u32Base          ̫ģַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetReset(uint32 u32Base)
{
    HWREG32(u32Base + ETH_DMABMR) |= 0x00000001;
}
/*********************************************************************************************************
** Function name:       EthernetResetStatusGet
** Descriptions:        ж̫Ƿڸλ״̬
** input parameters:    u32Base          ̫ģַ
** output parameters:   NONE
** Returned value:      true:  ̫ڸλ״̬
**                      false̫λ
*********************************************************************************************************/
boolean EthernetResetStatusGet(uint32 u32Base)
{
    if((HWREG32(u32Base + ETH_DMABMR)) & 0x00000001)
        return true;
    else
        return false;
}
/*********************************************************************************************************
** Function name:       EthernetDMAIntEnable
** Descriptions:        ʹ̫DMAж
** input parameters:    u32Base          ̫ģַ
**                      u32Config        ʹܵжԴȡֵֵĻ
**                      DMA_INTRUPT_NISE    //  жϻʹ
**                      DMA_INTRUPT_AISE    //  쳣жϻʹ
**                      DMA_INTRUPT_ERS     //  жʹ
**                      DMA_INTRUPT_FBES    //  жʹ
**                      DMA_INTRUPT_ETIE    //  緢жʹ
**                      DMA_INTRUPT_RWITE   //  ܿŹʱжʹ
**                      DMA_INTRUPT_RPSIE   //  ֹͣжʹ
**                      DMA_INTRUPT_RBUIE   //  ܻ治жʹ
**                      DMA_INTRUPT_RIE     //  жʹ
**                      DMA_INTRUPT_TUIE    //  жʹ
**                      DMA_INTRUPT_ROIE    //  洦жʹ
**                      DMA_INTRUPT_TITIE   //  ͆³ʱжʹ
**                      DMA_INTRUPT_TBUIE   //  ͻ治жʹ
**                      DMA_INTRUPT_TPSIE   //  ֹͣжʹ
**                      DMA_INTRUPT_TIE     //  жʹ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetDMAIntEnable(uint32 u32Base, uint32 u32Config)
{
    HWREG32(u32Base + ETH_DMAIER) |= u32Config;
}

/*********************************************************************************************************
** Function name:       EthernetDMAIntDisable
** Descriptions:        ̫DMAж
** input parameters:    u32Base          ̫ģַ
**                      u32Config        ܵжԴȡֵֵĻ
**                      DMA_INTRUPT_NISE    //  жϻʹ
**                      DMA_INTRUPT_AISE    //  쳣жϻʹ
**                      DMA_INTRUPT_ERS     //  жʹ
**                      DMA_INTRUPT_FBES    //  жʹ
**                      DMA_INTRUPT_ETIE    //  緢жʹ
**                      DMA_INTRUPT_RWITE   //  ܿŹʱжʹ
**                      DMA_INTRUPT_RPSIE   //  ֹͣжʹ
**                      DMA_INTRUPT_RBUIE   //  ܻ治жʹ
**                      DMA_INTRUPT_RIE     //  жʹ
**                      DMA_INTRUPT_TUIE    //  жʹ
**                      DMA_INTRUPT_ROIE    //  洦жʹ
**                      DMA_INTRUPT_TITIE   //  ͆³ʱжʹ
**                      DMA_INTRUPT_TBUIE   //  ͻ治жʹ
**                      DMA_INTRUPT_TPSIE   //  ֹͣжʹ
**                      DMA_INTRUPT_TIE     //  жʹ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void EthernetDMAIntDisable(uint32 u32Base, uint32 u32Config)
{
    HWREG32(u32Base + ETH_DMAIER) &= ~u32Config;
}
/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
