/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_exti.c
** Last modified Date:  2013-04-04
** Last Version:        v1.0
** Description:         extiģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-04
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#include "hal/arch/inc/arch_io_memmap.h"
#include "hal/arch/inc/arch_io_reg.h"
#include "hal/arch/inc/arch_io_exti.h"


/*********************************************************************************************************
  ֲ
*********************************************************************************************************/

/*********************************************************************************************************
** Function name:       ExtiIntEnable
** Descriptions:        EXTIжʹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void ExtiIntEnable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_IMR) |= ((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiIntDisable
** Descriptions:        EXTIжϽֹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void ExtiIntDisable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_IMR) &= ~((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiEventEnable
** Descriptions:        EXTI¼ʹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void ExtiEventEnable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_EMR) |= ((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiEventDisable
** Descriptions:        EXTI¼ֹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void ExtiEventDisable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_EMR) &= ~((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiIntEventRisingEnable
** Descriptions:        EXTIжϼ¼ʹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
** ע⣺غ½ͬʱʹܵʱͬʱЧ
*********************************************************************************************************/
void ExtiIntEventRisingEnable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_RTSR) |= ((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiIntEventRisingDisable
** Descriptions:        EXTIжϼ¼ؽֹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
** ע⣺غ½ͬʱʹܵʱͬʱЧ
*********************************************************************************************************/
void ExtiIntEventRisingDisable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_RTSR) &= ~((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiIntEventFallingEnable
** Descriptions:        EXTIжϼ¼½ʹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
** ע⣺غ½ͬʱʹܵʱͬʱЧ
*********************************************************************************************************/
void ExtiIntEventFallingEnable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_FTSR) |= ((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiIntEventFallingDisable
** Descriptions:        EXTIжϼ¼½ؽֹ
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
** ע⣺غ½ͬʱʹܵʱͬʱЧ
*********************************************************************************************************/
void ExtiIntEventFallingDisable(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_FTSR) &= ~((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiSoftInterruptTrigger
** Descriptions:        EXTIжϼ¼
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void ExtiSoftInterruptTrigger(uint32 u32Line)
{
    HWREG32(EXTI_BASE + EXTI_O_SWIER) |= ((uint32)1 << u32Line);
}

/*********************************************************************************************************
** Function name:       ExtiIntEventClear
** Descriptions:        EXTIжϼ¼
** input parameters:    u32Line:    ⲿӲжϺţȡ0-22
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void ExtiIntEventClear(uint32 u32Line)
{
     HWREG32(EXTI_BASE + EXTI_O_PR) |= ((uint32)1 << u32Line);
}
/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
