/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_flash.c
** Last modified Date:  2013-04-04
** Last Version:        v1.0
** Description:         flashģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-04
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#include "hal/arch/inc/arch_io_memmap.h"
#include "hal/arch/inc/arch_io_reg.h"
#include "hal/arch/inc/arch_io_flash.h"

extern void watchdog_periodic(void);
/*********************************************************************************************************
** Function name:       flashUnlock
** Descriptions:        flashģԲFlash
** input parameters:    NONE
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void flashUnlock(void)
{
    HWREG32(FLASH_BASE + FLASH_O_KEYR) = FLASH_UNLOCK_KER1;
    HWREG32(FLASH_BASE + FLASH_O_KEYR) = FLASH_UNLOCK_KER2;
    
#if (STM32F10XX_XL_Density > 0)
    HWREG32(FLASH_BASE + FLASH_O_KEYR2) = FLASH_UNLOCK_KER1;
    HWREG32(FLASH_BASE + FLASH_O_KEYR2) = FLASH_UNLOCK_KER2;
#endif
}

/*********************************************************************************************************
** Function name:       flashLock
** Descriptions:        flashģflash
** input parameters:    NONE
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void flashLock(void)
{
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000080;
    
#if (STM32F10XX_XL_Density > 0)
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000080;
#endif
}

/*********************************************************************************************************
** Function name:       flashPageErase
** Descriptions:        ָһҳ
** input parameters:    ulPageAddrָҳĵַͬϵоƬҳСܲͬ
** output parameters:   NONE
** Returned value:      trueɹ false: ˴󣬲ʧ
*********************************************************************************************************/
boolean flashPageErase(unsigned long ulPageAddr)
{
#if (STM32F10XX_XL_Density > 0)
  if(ulPageAddr < FLASH_BANK1_END_ADDRESS) {
      while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001){   //  ȴæ
        watchdog_periodic();
      }
      
      if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ϴûд,̴д
      {
          HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000002;       //  ѡҳ
          HWREG32(FLASH_BASE + FLASH_O_AR)  = ulPageAddr;       //  дҳַ
          HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000040;       //  
          while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001){ //  ȴ
            watchdog_periodic();
          }
          HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFD;       //  ҳɣҳ־
          if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ûд,̴д
          {
            return true;
          } else {
            return false;
          }
      } else {
          return false;
      }
  } else {
      while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001){   //  ȴæ
        watchdog_periodic();
      }
      
      if (!((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x0014))       //  ϴûд,̴д
      {
          HWREG32(FLASH_BASE + FLASH_O_CR2) |= 0x00000002;       //  ѡҳ
          HWREG32(FLASH_BASE + FLASH_O_AR2)  = ulPageAddr;       //  дҳַ
          HWREG32(FLASH_BASE + FLASH_O_CR2) |= 0x00000040;       //  
          while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001){ //  ȴ
            watchdog_periodic();
          }
          HWREG32(FLASH_BASE + FLASH_O_CR2) &= 0x00001FFD;       //  ҳɣҳ־
          if (!((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x0014))       //  ûд,̴д
          {
            return true;
          } else {
            return false;
          }
      } else {
          return false;
      }
  }
#else
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001){   //  ȴæ
      watchdog_periodic();
    }
      
    if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ϴûд,̴д
    {
        HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000002;       //  ѡҳ
        HWREG32(FLASH_BASE + FLASH_O_AR)  = ulPageAddr;       //  дҳַ
        HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000040;       //  
        while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001){ //  ȴ
          watchdog_periodic();
        }
        HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFD;       //  ҳɣҳ־
        if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ûд,̴д
        {
          return true;
        } else {
          return false;
        }
    } else {
        return false;
    }
#endif
}

/*********************************************************************************************************
** Function name:       flashMassErase
** Descriptions:        ȫƬflash
** input parameters:    NONE
** output parameters:   NONE
** Returned value:      trueɹ false: ˴󣬲ʧ
*********************************************************************************************************/
boolean flashMassErase(void)
{
#if (STM32F10XX_XL_Density > 0)
    // ȲBank1
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001){   //  ȴæ
      watchdog_periodic();
    }
    
    if (((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014)) {      //  ϴд,̴д
       return false;
    }
      
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000004;       //  ѡȫƬ
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000040;       //  
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001) { //  ȴ
      watchdog_periodic();
    }
    HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFB;       //  ȫƬɣ־
    if (((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014)) {      //  д,̴д
       return false;
    }
    
    // ٲBank2
    while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001){   //  ȴæ
      watchdog_periodic();
    }
    
    if (((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x0014)) {      //  ϴд,̴д
       return false;
    }
      
    HWREG32(FLASH_BASE + FLASH_O_CR2) |= 0x00000004;       //  ѡȫƬ
    HWREG32(FLASH_BASE + FLASH_O_CR2) |= 0x00000040;       //  
    while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001){ //  ȴ
      watchdog_periodic();
    }
    HWREG32(FLASH_BASE + FLASH_O_CR2) &= 0x00001FFB;       //  ȫƬɣ־
    if (((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x0014)) {      //  д,̴д
       return false;
    }
    
    return true;
  
  
#else
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001){   //  ȴæ
      watchdog_periodic();
    }
    
    if (((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014)) {      //  ϴд,̴д
       return false;
    }
      
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000004;       //  ѡȫƬ
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000040;       //  
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001){ //  ȴ
       watchdog_periodic();
    }
    HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFB;       //  ȫƬɣ־
    if (((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014)) {      //  д,̴д
       return false;
    }
    
    return true;
#endif
}

/*********************************************************************************************************
** Function name:       flashWriteHalfWord
** Descriptions:        Flashַָдһ16λ
** input parameters:    ulAddr:   ָдĵַ
**                      usData:   ָҪд
** output parameters:   NONE
** Returned value:      trueдɹ false: ˴дʧ
*********************************************************************************************************/
boolean flashWriteHalfWord(unsigned long ulAddr, unsigned short usData)
{
#if (STM32F10XX_XL_Density > 0)
   if(ulAddr < FLASH_BANK1_END_ADDRESS) {
      while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
      
      if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ϴûд,̴д
      {
          HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000001;        //  ѡflashģʽ
          HWREG16(ulAddr) = usData;                            //  д̵İ
          while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
          HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;        // ɣ̱־
          if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ûд,̴д
          {
            return true;
          } else {
            return false;
          }
      }
      return false;
   }else {
      while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001);   //  ȴæ
      
      if (!((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x0014))       //  ϴûд,̴д
      {
          HWREG32(FLASH_BASE + FLASH_O_CR2) |= 0x00000001;        //  ѡflashģʽ
          HWREG16(ulAddr) = usData;                            //  д̵İ
          while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001);   //  ȴæ
          HWREG32(FLASH_BASE + FLASH_O_CR2) &= 0x00001FFE;        // ɣ̱־
          if (!((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x0014))       //  ûд,̴д
          {
            return true;
          } else {
            return false;
          }
      }
      return false;
   }
#else 
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
    
    if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ϴûд,̴д
    {
        HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000001;        //  ѡflashģʽ
        HWREG16(ulAddr) = usData;                            //  д̵İ
        while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
        HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;        // ɣ̱־
        if (!((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x0014))       //  ûд,̴д
        {
          return true;
        } else {
          return false;
        }
    }
    return false;
#endif
}

/*********************************************************************************************************
** Function name:       flashProgram
** Descriptions:        Flashַָָֽڵ
** input parameters:    pusData:   ݻָ
**                      ulAddr:    ̵ַָ
**                      ulSize:    ̵ָֽ2ı
** output parameters:   NONE
** Returned value:      trueдɹ false: ˴дʧ
*********************************************************************************************************/
boolean flashProgram(unsigned short *pusData, unsigned long ulAddr, unsigned long ulSize)
{
    if ((ulSize < 2) || (ulAddr < 0x08000000) || ((ulSize % 2) != 0))
        return false;
    
#if (STM32F10XX_XL_Density > 0)
    if(ulAddr < FLASH_BANK1_END_ADDRESS) {
      while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
      
      HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000001;            //  ѡflashģʽ
    } else {
      goto FlashProgramBank2;
    }
    while(ulSize)
    {
        if((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x001)       //  ϴд,̴д
        {
            HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;    // ɣ̱־
            return false;
        }
        HWREG16(ulAddr) = *pusData;                          //  д̵İ
        while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
        pusData++;
        ulAddr += 2;
        ulSize -= 2;
        if(ulAddr > FLASH_BANK1_END_ADDRESS) {
          HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;       // ɣ̱־
          goto FlashProgramBank2;
        }
    }
    HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;            // ɣ̱־
    
FlashProgramBank2:
    while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001);   //  ȴæ
      
    HWREG32(FLASH_BASE + FLASH_O_CR2) |= 0x00000001;            //  ѡflashģʽ
    while(ulSize)
    {
        if((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x001)       //  ϴд,̴д
        {
            HWREG32(FLASH_BASE + FLASH_O_CR2) &= 0x00001FFE;    // ɣ̱־
            return false;
        }
        HWREG16(ulAddr) = *pusData;                          //  д̵İ
        while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001);   //  ȴæ
        pusData++;
        ulAddr += 2;
        ulSize -= 2;
    }
    HWREG32(FLASH_BASE + FLASH_O_CR2) &= 0x00001FFE;            // ɣ̱־
    
    return true;
#else
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
    
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000001;            //  ѡflashģʽ
    while(ulSize)
    {
        if((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x001)       //  ϴд,̴д
        {
            HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;    // ɣ̱־
            return false;
        }
        HWREG16(ulAddr) = *pusData;                          //  д̵İ
        while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
        pusData++;
        ulAddr += 2;
        ulSize -= 2;
    }
    HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;            // ɣ̱־
    return true;
#endif
}

/*********************************************************************************************************
** Function name:       flashConstDataProgram
** Descriptions:        Flashַָд̶
** input parameters:    usData:    ̵Ĺ̶
**                      ulAddr:    ̵ַָ
**                      ulSize:    ̵ָֽ2ı
** output parameters:   NONE
** Returned value:      trueдɹ false: ˴дʧ
*********************************************************************************************************/
boolean flashConstDataProgram(unsigned short usData, unsigned long ulAddr, unsigned long ulSize)
{
    if ((ulSize < 2) || (ulAddr < 0x08000000) || ((ulSize % 2) != 0))
        return false;
#if (STM32F10XX_XL_Density > 0)
    if(ulAddr < FLASH_BANK1_END_ADDRESS) {
      while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
      
      HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000001;            //  ѡflashģʽ
    } else {
      goto FlashProgramConstBank2;
    }
    while(ulSize)
    {
        if((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x001)       //  ϴд,̴д
        {
            HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;    // ɣ̱־
            return false;
        }
        HWREG16(ulAddr) = usData;                          //  д̵İ
        while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
        ulAddr += 2;
        ulSize -= 2;
        if(ulAddr > FLASH_BANK1_END_ADDRESS) {
          HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;            // ɣ̱־
          goto FlashProgramConstBank2;
        }
    }
    HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;            // ɣ̱־
    
FlashProgramConstBank2:
    while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001);   //  ȴæ
      
    HWREG32(FLASH_BASE + FLASH_O_CR2) |= 0x00000001;            //  ѡflashģʽ
    while(ulSize)
    {
        if((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x001)       //  ϴд,̴д
        {
            HWREG32(FLASH_BASE + FLASH_O_CR2) &= 0x00001FFE;    // ɣ̱־
            return false;
        }
        HWREG16(ulAddr) = usData;                          //  д̵İ
        while((HWREG32(FLASH_BASE + FLASH_O_SR2)) & 0x00000001);   //  ȴæ
        ulAddr += 2;
        ulSize -= 2;
    }
    HWREG32(FLASH_BASE + FLASH_O_CR2) &= 0x00001FFE;            // ɣ̱־
    
    return true;
#else 
    while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
    
    HWREG32(FLASH_BASE + FLASH_O_CR) |= 0x00000001;            //  ѡflashģʽ
    while(ulSize)
    {
        if((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x001)       //  ϴд,̴д
        {
            HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;    // ɣ̱־
            return false;
        }
        HWREG16(ulAddr) = usData;                          //  д̵İ
        while((HWREG32(FLASH_BASE + FLASH_O_SR)) & 0x00000001);   //  ȴæ
        ulAddr += 2;
        ulSize -= 2;
    }
    HWREG32(FLASH_BASE + FLASH_O_CR) &= 0x00001FFE;            // ɣ̱־
    return true;
#endif
}

/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
